
/***************************************************/
// Test Data
/***************************************************/

var testdata = new Array();    
testdata[0] = new Array	("Homer", "00:13:46:F5:6F:70", "D-Link", 9, 14, 2, 0);
testdata[1] = new Array("Jen", "00:0F:3D:00:C2:1D", "D-Link", 6, 14, 1, 0);
testdata[2] = new Array("concorde", "00:13:10:77:87:FB", "Linksys", 2, 24, 2, 0); 
testdata[3] = new Array("Carbon", "00:11:24:27:AF:CF", "Apple", 8, 26, 2, 0);
testdata[4] = new Array("Swinger", "00:0F:66:E3:4D:F4", "Linksys", 6, 14, 0, 0); 
testdata[5] = new Array("default", "00:13:46:C8:19:28", "D-Link", 6, -1, 1, 0); 
testdata[6] = new Array("newGR", "00:13:10:D4:2F:D8", "Linksys", 6, 27, 1, 0);
testdata[7] = new Array("Shaw1", "00:13:46:F5:60:F4", "D-Link", 6, 26, 1, 0);

/***************************************************/
// Variables
/***************************************************/

var scrollbar
var scrollArea;
var oldContent;
var oldControl;
var centerHeightFront = 196;

var networkList;
var myNetwork = new WirelessNetwork();

var updateTimer = 1000; 
var updateInterval;

var scanForClosed = false;
var closedSearchName = "";

var nextUpdateCheck = (new Date()).getTime();

var networkList = new WirelessNetworkList();

/***************************************************/
// Widget Update Methods
/***************************************************/

if(window.widget){
	widget.onshow = onshow;
	widget.onhide = onhide;
	widget.onremove = onremove;
}

if(window.widget){
	widget.onshow = onshow;
	widget.onhide = onhide;
	widget.onremove = onremove;
}

onshow();

function onshow(){			
	if(updateInterval == null)
		updateInterval = setInterval("_update();", updateTimer);
		
		
	if( window.AirTrafficControl2)
		window.AirTrafficControl2.setScanner(true);	
		
	setTimeout ('updateATCWithPermission();', 0);
}

function onhide(){
	if(updateInterval != null){
		clearInterval(updateInterval);
		updateInterval = null;
		if( window.AirTrafficControl2)
			window.AirTrafficControl2.setScanner(false);
	}
}

function onremove ()
{
		if(updateInterval != null){
			clearInterval(updateInterval);
		updateInterval = null;
	}
		if( window.AirTrafficControl2)
			window.AirTrafficControl2.setScanner(false);
		widget.setPreferenceForKey (null, widget.identifier);
}

function updateUpdateInterval(){
	if(updateInterval != null)
		clearInterval(updateInterval);
	updateInterval = setInterval("_update();", updateTimer);
	
}

/* Callled on page load */
function init(){
	loadScrollBar();
	loadStretcher();
		
	showContent($('network-scroll-area'), null);
		   
	scrollArea.refresh();
	scrollbar.fixScrollbarPosition();
	
	var sb1 = new AppleButton( $("stop-scan-button"), " ", 23, "", "", 0, "","", "images/power_f01.png","images/power_f02.png", 24, null);
	var sb2 = new AppleButton( $("start-scan-button"), " ", 23, "", "", 0, "","", "images/power_f03.png","images/power_f04.png", 24, MessageBox.showScan);
	var gSaveButton  = new AppleGlassButton($("back-save-button"), "Save", hideAndSave);
	var gCancelButton  = new AppleGlassButton($("back-cancel-button"), "Cancel", hideAndCancel);
	var gInfoButton = new AppleInfoButton($("info-button"), $("front"), "black", "black", showBack);
	gCancelButton.textElement.style.color = "#333333";
	gSaveButton.textElement.style.color = "#333333";
	
	
	setDefaultPrefs();
	loadPrefs();
	
	updateVersion();
	
	setTimeout ('updateATCWithPermission();', 0);
	
	stretchTheFrame(event);	

//	readPrefsFromFile();
//	checkForAirPortVersion();
//	intitUpdate();
}

function updateVersion(){
	version = window.AirTrafficControl2.getWidgetVersion();
	$('back-title').innerText = "AirTrafficControl " + version;
	

}

/***************************************************/
// Other Methods
/***************************************************/


function gotoST(){
	if(window.widget){
		widget.openURL("http://www.spintriplet.com");
	}
}

function gotoSupport(){
	if(window.widget){
		widget.openURL("http://www.spintriplet.com/atc2/support.php");
	}
}


function gotoUpdate(){
	if(window.widget){
		widget.openURL("http://www.spintriplet.com/atc/update.php");
	}
}

function updateATCWithPermission(){
	
	//alert(nextUpdateCheck);
	//alert((new Date()).getTime());
	
	if(nextUpdateCheck < (new Date()).getTime()){
		//alert("UPDATE STATUS: " + window.AirTrafficControl2.vendorUpdateAvailable());
		
		nextUpdateCheck = (new Date()).getTime() + 10000; // * 60 * 60 *24;
		
		if(widget.preferenceForKey("update")  && window.AirTrafficControl2.vendorUpdateAvailable()){
			alert("AirTraffic control is updating the network vendors list.");
			window.AirTrafficControl2.updateVendors();
		}
		if(widget.preferenceForKey("update") && window.AirTrafficControl2.updateAvailable()){
			// Open some sort of dialog that says there is an update and OK = GOTO ST DOWNLOAD
			// Cancel = hide.
			if(!stretcher.isStretched()){
				stretchTheFrame(null);
				MessageBox.showUpdate();
			}
		}
	
	}
	
}

///*********** CODE THAT SAVES THE PREFS FROM THE BACK

function setDefaultPrefs(){
	if( widget.preferenceForKey("saved-prefs") == null || widget.preferenceForKey("saved-prefs") == false){
		
		window.AirTrafficControl2.installDefaultPolicies();
		
		widget.setPreferenceForKey(true,"require-admin");
		widget.setPreferenceForKey(true,"require-auth");
		widget.setPreferenceForKey(true,"update");
		widget.setPreferenceForKey(2,"selected-index");
		widget.setPreferenceForKey(10000,"scanrate");
		widget.setPreferenceForKey(true, "saved-prefs");
	}
}


function loadPrefs(){
	var rate = widget.preferenceForKey("scanrate");
	$("admin-checkbox").checked = widget.preferenceForKey("require-admin");
	$("authentication-checkbox").checked = widget.preferenceForKey("require-auth");
	$("auto-update").checked = widget.preferenceForKey("update");
	$("scan-selection").selectedIndex = widget.preferenceForKey("selected-index");
	//alert(widget.preferenceForKey("scanrate"));
	window.AirTrafficControl2.updateScanInterval(rate);
}


function savePrefs(){
	var requireAdministrator = $("admin-checkbox").checked;
	var requireAuthentication = $("authentication-checkbox").checked;
	
	// NO CHANGE TO THE AUTH STUFF SO DON"T SAVE IT!!!
	if(requireAdministrator == widget.preferenceForKey("require-admin") && requireAuthentication == widget.preferenceForKey("require-auth")){
	
		updateTimer = $("scan-selection").options[$("scan-selection").selectedIndex].value;
		
		widget.setPreferenceForKey($("auto-update").checked,"update");
		widget.setPreferenceForKey(updateTimer,"scanrate");
		widget.setPreferenceForKey($("scan-selection").selectedIndex, "selected-index");
		return true;
	}
	//SAVE THE AUTH STUFF
	else if(window.AirTrafficControl2.selfRestrict(requireAdministrator, requireAuthentication)){
		
		updateTimer = $("scan-selection").options[$("scan-selection").selectedIndex].value;
		
		widget.setPreferenceForKey($("admin-checkbox").checked ,"require-admin");
		widget.setPreferenceForKey($("authentication-checkbox").checked,"require-auth");
		widget.setPreferenceForKey($("auto-update").checked,"update");
		widget.setPreferenceForKey(updateTimer,"scanrate");
		widget.setPreferenceForKey($("scan-selection").selectedIndex, "selected-index");
		
		return true;
	}
	// IF THEY CANCEL THE PASSWORD DIALOG, DON'T FLIP. MAKE THEM CANCEL CHANGES!
	else{
		loadPrefs();
		return false;
	}
}


function hideBack(){    
	
	var front = $("front");
    var back = $("back");
 
    if (window.widget)
        widget.prepareForTransition("ToFront");
 
    back.style.display="none";
    front.style.display="block";
 
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);

}

function showBack(){    
	
	var front = $("front");
    var back = $("back");
 
    if (window.widget)
        widget.prepareForTransition("ToBack");
 
    front.style.display="none";
    back.style.display="block";
 
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);  
	
}

function hideAndCancel(){
	hideBack();
	loadPrefs();
}

function hideAndSave(){
	if(savePrefs())
		hideBack();
	loadPrefs();
}

function _update(){
	setTimeout ('update();', 0);	
}

function update(){	
	if(window.AirTrafficControl2){
		// Wait a second to make sure that the data has been updated by the thread
		if( (ResizeBox.resizing == null || ResizeBox.resizing == false) && (scrollbar.scrolling == null || scrollbar.scrolling == false))
			setTimeout ('updateAirPortAfterScan();', 0);

	}
}

function intitUpdate(){	
	if(window.AirTrafficControl2){
		setTimeout ('updateAirPortAfterScan();', 0);

	}
	else{
		$('signal_image').src = "images/signaloff.png";
	}
}

function updateAirPortAfterScan(){	
	var currentInfo = window.AirTrafficControl2.currentStatus();
	var error = window.AirTrafficControl2.statusError();
	
	//Carbon,Apple,00:11:24:27:AF:CF,60,4,1,48,1,1,54,-128,false,WPA2:AES-CCMP
	var networkArray;
	

	networkArray = window.AirTrafficControl2.networkList(false);

	
	if(networkArray != null && networkArray.length > 0){
		
		networkList.refresh();
	
		for(i = 0; i<networkArray.length; i++){
			networkList.addNetworkFromArray( networkArray[i], true);
		}
		
		networkList.sortByStrength();
		$('network-scroll-area').innerHTML = networkList.toHTML();
	
	}
	else{
		$('network-scroll-area').innerHTML = "";
	}
	
		
	if(currentInfo == null)
	{
		if(window.AirTrafficControl2.powerOn() && window.AirTrafficControl2.enabled())
		{
			myNetwork.update("N/A", "No Connection", "00:00:00:00:00:00", 0, "", 1);
	
		}
		else
		{
			myNetwork.update("ERROR", "AirPort is off.", "00:00:00:00:00:00", 0, "", 1);
			
		}
			//alert(currentInfo[0] + " " + currentInfo[1] + " " + currentInfo[2] + " " + currentInfo[3] + " " + currentInfo[12] + " " + currentInfo[6]);
			myNetwork.updateHTML($('status-mask'), $('mask-image'),$('current-name'),
			$('current-vendor') ,$('current-speed') ,$('current-encryption'));
		
	}
	else{
		setConnectedMode();
		myNetwork.update(currentInfo[0], currentInfo[1], currentInfo[2], currentInfo[3], currentInfo[12], currentInfo[6]);
		//alert(currentInfo[0] + " " + currentInfo[1] + " " + currentInfo[2] + " " + currentInfo[3] + " " + currentInfo[12] + " " + currentInfo[6]);
		myNetwork.updateHTML($('status-mask'), $('mask-image'),$('current-name'),
			$('current-vendor') ,$('current-speed') ,$('current-encryption'));
		   
	}
	scrollArea.refresh();
	

}

function checkConnectionBeforeScan(){
	// tests to see if we are connected to a network. if so we need to warn the user that scanning will disrupt communications.	
}

function continueConnectionToNetwork(){
	var obj = MessageBox.obj;
	if(obj == null){
		
	}
	else if(obj.encryptionType == 1 && password != null){
	
	}
	else if(obj.encryptionType == 2 && password != null){
	
	}
	
	MessageBox.hide();
}


/*************************  ATC CODE - NEEDED TO CLEAN UP THE MESS *********************************/

function NetworkSummary(ssid, macAddress, encryptionType){
	this.ssid = ssid;
	this.macAddress = macAddress;
	this.encryptionType = encryptionType;
	this.key = null;
}

NetworkSummary.prototype._getKey = function(){
	this.key = $('password-input').value;
	window.AirTrafficControl2.storePassword(this.key, this.ssid);
	var _network_summary = this;
	setTimeout (function(){_network_summary._connectWithNewKey();}, 0);

}

NetworkSummary.prototype._connectWithNewKey = function(){
	switch(this.encryptionType){
		case 0:
			if( !window.AirTrafficControl2.connect(this.macAddress))
				this._warnConnectionFailed( window.AirTrafficControl2.statusError());
		break;
		case 1:
			if( !window.AirTrafficControl2.connectWEP(this.macAddress, this.key))
				this._warnConnectionFailed(window.AirTrafficControl2.statusError());
		break;
		case 2:
			if( !window.AirTrafficControl2.connectWPA(this.macAddress, this.key))
				this._warnConnectionFailed(window.AirTrafficControl2.statusError());
		break;
		default:
			alert("There was a connection error.");
		break;	
	}
	
	this.key = null;
		
}

NetworkSummary.prototype._warnConnectionFailed = function(error){
	MessageBox.show("Connection Error","Unable to connect to specified network.");
}


NetworkSummary.prototype._connect = function(){
	clearSearch();
	switch(this.encryptionType){
		case 0:
			// There is no encryption so just connect.
			this._connectWithNewKey();
		break;
		case 1:
			// we need to find a WEP key, if it is in the keychain use it
			// if the keychain entry is bad, or it is not in there ask the user
			this.key = window.AirTrafficControl2.getPasswordForNetwork(this.ssid);
			if(this.key == null)
				MessageBox.showPassword(this);
			else{
				if( !window.AirTrafficControl2.connectWEP(this.macAddress, this.key)){
					MessageBox.showPassword(this);
				
				}
			}
		break;
		case 2:
			// we need to find a WPA key, if it is in the keychain use it
			// if the keychain entry is bad, or it is not in there ask the user
			this.key = window.AirTrafficControl2.getPasswordForNetwork(this.ssid);
			if(this.key == null)
				MessageBox.showPassword(this);
			else{
				if( !window.AirTrafficControl2.connectWPA(this.macAddress, this.key))
					MessageBox.showPassword(this);
			}
				
		break;
		default:
		break;	
	}
	key = null;
	
}




/********************** MESSAGE BOX ******************************************/

var MessageBox = new Object();
var okbutton;
var cancelbutton;

MessageBox.obj = null;


MessageBox.show = function (title, bodyHTML){
	var overlay = new Overlay($('cover'), "message-box", true, false, false, true, 
		title, "", bodyHTML, function(){});
}

MessageBox.showScan = function(){
	
	var overlay = new Overlay($('cover'), "message-box", true, true, false, false, 
		"Disconnect from network?", "", 
		"To initiate an active scan you must first disconnect from the current network. Do you want to disconnect and start scanning?", 
		setDisconnectedMode);
}

MessageBox.showUpdate = function(){
	
	var overlay = new Overlay($('cover'), "message-box", true, true, false, false, 
		"Update Available!", "", 
		"A new version of AirTrafficControl is available. Since you are running a pre-release build it is strongly reccomended that you update.<br /><br />Would you like to get more information?",
		gotoUpdate);
	
}


MessageBox.showPassword = function (networkSummary){

	var overlay = new Overlay($('cover'), "message-box", true, true, true, true, 
		"Enter Network Password", "", 
		"The password for the network <br /> \"<b><i>"+ networkSummary.ssid +"</b></i>\" was not found in your keychain. <br /> <br /> <b>Password:</b>",
		function(){networkSummary._getKey();});
}

function passwordOK(){
	return $('password-input').value;
}


function setConnectedMode(){
	$("start-scan-button").style.display = "block";
	$("stop-scan-button").style.display = "none";
	
}

function setDisconnectedMode(){
	$("stop-scan-button").style.display = "block";
	$("start-scan-button").style.display = "none";
		
	window.AirTrafficControl2.disconnect();	
}

/************** RESIZE, STRETCH, AND SCROLL - THANKS APPLE *******************/

var stretcher;
var searchbox;

function searchHasFocus (){
	searchbox = $('search-box');
	if(searchbox.value == "Scan Closed Network"){
		searchbox.value = "";
	}
	searchbox.style.color = "#000000";
}

function searchIsBlurred(){
	searchbox = $('search-box');
	if(searchbox.value == ""){
		searchbox.value = "Scan Closed Network";
		searchbox.style.color = "#999999";
	}
	else	
		searchbox.style.color = "#000000";
}

function runSearch(){
	
	searchbox = $('search-box');
	directedScanName = searchbox.value;
	//alert("scanning for: "+name);

	if( directedScanName.length > 0 && directedScanName.indexOf("Scan Closed Network") < 0){
	
		scanForClosed = true;
		window.AirTrafficControl2.directedScan(directedScanName);	
	}
	else{
		scanForClosed = false;
		window.AirTrafficControl2.directedScan(null);	
	}

}

function clearSearch(){
	searchbox = $('search-box');
	searchbox.value = "";
	searchbox.blur();
	runSearch();
}


function loadStretcher () {
	stretcher = new Stretcher($('front'), centerHeightFront, 200, changed);
}

// Callback for when the stretcher finishes a stretch/shrink
// Based on the state of the widget, display the right status text
function changed () {
	//scrollArea.refresh();
	if(stretcher.isStretched()){
		;
	}
	else{
		$("front-center").style.background = "none";
		$("menu").style.background = "none";
		$("front-bottom").style.background = "url(images/bottom-background.png) no-repeat bottom left";
	}
}

function stretchTheFrame(e){
	if(stretcher.isStretched()){
		;
	}
	else{
		$("front-center").style.background = "url(images/center-background.png)  repeat-y bottom left";
		$("menu").style.background = "url(images/menu-background.png)  repeat-y bottom left";
		$("front-bottom").style.background = "url(images/bottom-background-open.png) no-repeat bottom left";
	
	}
	
	stretcher.stretch(e);
	
}

function loadScrollBar() {
	scrollbar = new AppleVerticalScrollbar($("scroll-bar"));
	scrollArea = new AppleScrollArea($("networks"), scrollbar);
	scrollArea.scrollsHorizontally = false;
	scrollArea.singlepressScrollPixels = 25;
	scrollArea.focus(); // for key control when first loading in Safari
	
	window.onfocus = function () { scrollArea.focus(); }
	window.onblur = function () { scrollArea.blur(); }
}

// Switches between the content DIVs.
function showContent(newContent, newControl) {
	if (oldContent != null) {
		oldContent.style.display = 'none';
		//oldControl.style.color = 'gray';
	}
	
	//newControl.style.color = 'black';
	newContent.style.display = 'block';
	
	// Resize, reposition the scrollthumb
	scrollArea.reveal(newContent);
	scrollArea.refresh();

	oldContent = newContent;
	//oldControl = newControl;
}	


/*======================================================================
 *	Resize Box
 *======================================================================*/
var ResizeBox = new Object ();
var Window = new Object ();

Window.currentSize = function () {
	var obj1 = $("front-center");
	var obj2 = $("front");
	return obj2.offsetHeight;
}

ResizeBox.mouseDown = function (event) {
	var obj1 = $("front-center");
	var obj2 = $("front");
	ResizeBox.resizing = true;
	
	//alert("Center:"+obj1.offsetHeight + "  | Whole:"+ obj2.offsetHeight);
	
	ResizeBox.clickOffset1 = obj1.offsetHeight - event.y;
	ResizeBox.clickOffset2 = obj2.offsetHeight - event.y;
	document.addEventListener("mousemove", ResizeBox.mouseMove, true); 
	document.addEventListener("mouseup", ResizeBox.mouseUp, true); 
	event.stopPropagation();
    event.preventDefault();
}

ResizeBox.mouseMove = function (event) {
	var obj1 = $("front-center");
	var obj2 = $("front");
	ResizeBox.resizing = true;
	
	if(ResizeBox.clickOffset1 + event.y >= 121){
	
		obj1.style.height = ResizeBox.clickOffset1 + event.y + "px";
		obj2.style.height = ResizeBox.clickOffset2 + event.y + "px";
	
	}
	else{
	
		obj1.style.height = "121px";
		obj2.style.height = "169px";
	
	}
	
	event.stopPropagation();
    event.preventDefault();
    
    window.resizeTo(window.innerWidth, obj2.offsetHeight);
    stretcher.updateStretchDistance(obj1.offsetHeight); 
   
  
	scrollArea.refresh();
	scrollbar.fixScrollbarPosition();
}

ResizeBox.mouseUp = function (event) { 
	var obj1 = $("front-center");
	var obj2 = $("front");
	ResizeBox.resizing = false;
	
	if(ResizeBox.clickOffset1 + event.y >= 121){
	
		obj1.style.height = ResizeBox.clickOffset1 + event.y + "px";
		obj2.style.height = ResizeBox.clickOffset2 + event.y + "px";
	
	}
	else{
	
		obj1.style.height = "121px";
		obj2.style.height = "169px";
	
	}
	
    document.removeEventListener("mousemove", ResizeBox.mouseMove, true); 
    document.removeEventListener("mouseup", ResizeBox.mouseUp, true); 
    event.stopPropagation();
    event.preventDefault();
    
    window.resizeTo(window.innerWidth, obj2.offsetHeight);
    stretcher.updateStretchDistance(obj1.offsetHeight); 
   
	scrollArea.refresh();
	scrollbar.fixScrollbarPosition();
}



